%def_with mdns
%def_with python
%def_with mono

%ifndef _qt3dir
%define _qt3dir %_libdir/qt3
%endif

%define avahi_user _avahi
%define autoipd_user _autoipd
%define avahi_group_priv netadmin

Name: avahi
Version: 0.6.22
Release: alt6.M41.2

Summary: Local network service discovery
License: LGPL
Group: System/Servers
Url: http://www.avahi.org/

Source: %name-%version-%release.tar

# Security patches
Patch21: CVE-2009-0758.patch
Patch22: CVE-2010-2244.patch
Patch23: CVE-2011-1002.patch

Requires: %name-autoipd = %version-%release
Requires: %name-daemon = %version-%release
Requires: %name-dnsconfd = %version-%release

%if_with mdns
Obsoletes: mdnsresponder
%endif

BuildPreReq: /proc
BuildRequires: doxygen gcc-c++ glib2-devel graphviz intltool libcap-devel libdaemon-devel libdbus-devel libexpat-devel libgdbm-devel libglade2-devel libgtk+2-devel libqt3-devel libqt4-devel xmltoman
%{?_with_python:BuildRequires: python-devel python-module-pygtk python-module-dbus}
%{?_with_mono:BuildRequires: libgtk-sharp2-devel mono-mcs monodoc}

%description
Avahi is a system which facilitates service discovery on
a local network -- this means that you can plug your laptop or
computer into a network and instantly be able to view other people
who you can chat with, find printers to print to or find files being
shared. This kind of technology is already found in MacOS X
(branded 'Rendezvous', 'Bonjour' and sometimes 'ZeroConf')
and is very convenient.

%package autoipd
Summary: Assigning link-local IP addresses service
Group: System/Servers
Requires(pre): shadow-utils
Conflicts: lib%name > %version-%release
Conflicts: lib%name < %version-%release

%package daemon
Summary: Local network service discovery
Group: System/Servers
Requires(pre): shadow-utils
Requires: chrooted-resolv dbus lib%name = %version-%release
Requires(post): %post_service dbus-tools
Requires(preun): %preun_service

%package dnsconfd
Summary: DNS configuration aquiring service
Group: System/Servers
Requires: lib%name = %version-%release %name-daemon = %version-%release

%package -n lib%name
Summary: Libraries for avahi
Group: System/Libraries

%if_with mdns
Obsoletes: libmdnsresponder
Provides: libmdnsresponder
%endif

%package -n lib%name-devel
Summary: Libraries and header files for avahi development
Group: Development/C
Requires: lib%name = %version-%release

%if_with mdns
Obsoletes: libmdnsresponder-devel
%endif

%package -n lib%name-glib
Summary: Glib libraries for avahi
Group: System/Libraries
Requires: lib%name = %version-%release

%package -n lib%name-glib-devel
Summary: Libraries and header files for avahi glib development
Group: Development/C
Requires: lib%name-devel = %version-%release
Requires: lib%name-glib = %version-%release
Requires: glib2-devel

%package -n lib%name-gobject
Summary: GObject'ified version of avahi API
Group: System/Libraries
Requires: lib%name = %version-%release
Requires: lib%name-glib = %version-%release

%package -n lib%name-gobject-devel
Summary: Libraries and header files for avahi gobject development
Group: Development/C
Requires: lib%name-devel = %version-%release
Requires: lib%name-glib-devel = %version-%release
Requires: lib%name-gobject = %version-%release

%package -n lib%name-qt3
Summary: Qt3 libraries for avahi
Group: System/Libraries
Requires: lib%name = %version-%release

%package -n lib%name-qt3-devel
Summary: Libraries and header files for avahi Qt3 development
Group: Development/KDE and QT
Requires: lib%name-devel = %version-%release
Requires: lib%name-qt3 = %version
Requires: libqt3-devel

%package -n lib%name-qt4
Summary: Qt4 libraries for avahi
Group: System/Libraries
Requires: lib%name = %version-%release

%package -n lib%name-qt4-devel
Summary: Libraries and header files for avahi Qt4 development
Group: Development/KDE and QT
Requires: lib%name-devel = %version-%release
Requires: lib%name-qt4 = %version
Requires: libqt4-devel

%package -n lib%name-ui
Summary: UI libraries for avahi
Group: System/Libraries
Requires: lib%name = %version-%release
Requires: lib%name-glib = %version-%release

%package -n lib%name-ui-devel
Summary: Libraries and header files for avahi UI development
Group: Development/GNOME and GTK+
Requires: lib%name-devel = %version-%release
Requires: lib%name-glib-devel = %version-%release
Requires: lib%name-ui = %version-%release

%package -n lib%name-sharp
Summary: Mono bindings for avahi
Group: Development/Other
Requires: lib%name = %version-%release

%package -n lib%name-ui-sharp
Summary: GTK/Sharp bindings for avahi
Group: Development/Other
Requires: lib%name-ui = %version-%release

%package -n python-module-%name
Summary: Python bindings for Avahi
Group: Development/Python

%package bookmarks
Summary: Web service showing mDNS/DNS-SD announced HTTP services using the Avahi
Group: Networking/WWW
# still needed. that sucks
%py_requires avahi gobject dbus twisted twisted.internet
# p-m-t-w doesn't provide twisted.web. that sucks too
Requires: python-module-twisted-web

%package tools
Summary: Tools for mDNS browsing and publishing
Group: System/Base
Requires: lib%name = %version-%release

%package ui
Summary: UI tools for mDNS discovery
Group: Graphical desktop/Other
Conflicts: lib%name > %version-%release
Conflicts: lib%name < %version-%release
%py_requires avahi gtk gobject dbus libglade

# {{{ descriptions

%description autoipd
avahi-autoipd is an implementation of IPv4LL as defined in RFC3927,
a technology for assigning link-local IP addresses without DHCP server.
The same functionality has been available on Windows under the name APIPA.
While it is not the first implemenatation of this technology
for Free operating systems it is clearly the most powerful and hopefully
even the most secure. (Because it chroot()s and drops priviliges and suchlike)

%description daemon
Avahi is a system which facilitates service discovery on
a local network -- this means that you can plug your laptop or
computer into a network and instantly be able to view other people
who you can chat with, find printers to print to or find files being
shared. This kind of technology is already found in MacOS X
(branded 'Rendezvous', 'Bonjour' and sometimes 'ZeroConf')
and is very convenient.

This package provides avahi daemon.

%description dnsconfd
Avahi is a system which facilitates service discovery on
a local network -- this means that you can plug your laptop or
computer into a network and instantly be able to view other people
who you can chat with, find printers to print to or find files being
shared. This kind of technology is already found in MacOS X
(branded 'Rendezvous', 'Bonjour' and sometimes 'ZeroConf')
and is very convenient.

This package provides complementary DNS tracking service.

%description -n lib%name
Libraries for use of avahi.

%description -n lib%name-devel
Header files and libraries necessary for developing
programs using avahi.

%description -n lib%name-glib
Libraries for easy use of avahi from glib applications.

%description -n lib%name-glib-devel
Header files and libraries necessary for developing
programs using avahi with glib.

%description -n lib%name-gobject
GObject'ified version of avahi API

%description -n lib%name-gobject-devel
Header files and libraries necessary for developing
programs using avahi with GObject/glib.

%description -n lib%name-qt3
Libraries for easy use of avahi from Qt3 applications.

%description -n lib%name-qt3-devel
Header files and libraries necessary for developing
programs using avahi with Qt3.

%description -n lib%name-qt4
Libraries for easy use of avahi from Qt4 applications.

%description -n lib%name-qt4-devel
Header files and libraries necessary for developing
programs using avahi with Qt4.

%description -n lib%name-ui
Libraries for easy use of avahi from UI applications.

%description -n lib%name-ui-devel
Header files and libraries necessary for developing
programs using avahi with UI.

%description bookmarks
A web service for listing HTTP services that are announced via mDNS/DNS-SD
using the Avahi daemon. %name opens a TCP socket on port 8080 and waits for
incoming HTTP connections returning a dynamic web site containing links
to all services of type _http._tcp on the LAN.
Point your browser to http://localhost:8080/ to make use of avahi-bookmarks.

%description tools
command-line utilitiesthat use avahi to browse and publish mDNS services and hosts.

%description ui
Various UI tools that use avahi to discover and use mDNS services and hosts.

%description -n lib%name-sharp
Mono bindings for Avahi.

%description -n lib%name-ui-sharp
GTK/Sharp bindings for Avahi.

%description -n python-module-%name
Python bindings for Avahi.

# }}}

%prep
%setup
%patch21 -p1
%patch22 -p1
%patch23 -p1

touch config.rpath

%build
%autoreconf
%configure \
    --localstatedir=%_var \
    --with-distro=altlinux \
    --enable-core-docs \
%if_with mono
    --enable-mono \
    --enable-monodoc \
%else
    --disable-mono \
    --disable-monodoc \
%endif
    --disable-compat-howl \
    --disable-static \
%if_with python
    --enable-python \
    --enable-pygtk \
    --enable-python-dbus \
%else
    --disable-python \
    --disable-pygtk \
    --disable-python-dbus \
%endif
%if_with mdns
    --enable-compat-libdns_sd \
%endif
    --with-avahi-user=%avahi_user \
    --with-avahi-group=%avahi_user \
    --with-avahi-priv-access-group=%avahi_group_priv \
    --with-autoipd-user=%autoipd_user \
    --with-autoipd-group=%autoipd_user

%make_build

%install
%make_install DESTDIR=%buildroot \
    pythondir=%python_sitelibdir \
    pyexecdir=%python_sitelibdir \
    install

mkdir -p %buildroot%_var/resolv/var/avahi \
    %buildroot%_var/run/avahi-daemon \
    %buildroot%_localstatedir/autoipd \
    %buildroot%_var/run/autoipd

ln -s resolv/var/avahi %buildroot%_var/avahi

find %buildroot%_libdir -name '*.la' -delete

%pre autoipd
/usr/sbin/groupadd -r -f %autoipd_user &>/dev/null ||:
/usr/sbin/useradd -r -g %autoipd_user -d %_localstatedir/autoipd -s /dev/null \
    -c "Avahi autoipd service" -M -n %autoipd_user &>/dev/null ||:

%pre daemon
/usr/sbin/groupadd -r -f %avahi_user &>/dev/null ||:
/usr/sbin/useradd -r -g %avahi_user -d %_var/run/avahi-daemon -s /dev/null \
    -c "Avahi service" -M -n %avahi_user &>/dev/null ||:

%post daemon
%post_service avahi-daemon
/sbin/service avahi-dnsconfd condrestart 2>/dev/null ||:
if /sbin/service messagebus status &>/dev/null; then
dbus-send --system --type=method_call --dest=org.freedesktop.DBus / org.freedesktop.DBus.ReloadConfig &>/dev/null ||:
else
echo "Avahi requires running messagebus service." >&2
fi

%preun daemon
%preun_service avahi-daemon

%post -n lib%name
%post_ldconfig

%postun -n lib%name
%postun_ldconfig

%post -n lib%name-glib
%post_ldconfig

%postun -n lib%name-glib
%postun_ldconfig

%post -n lib%name-gobject
%post_ldconfig

%postun -n lib%name-gobject
%postun_ldconfig

%post -n lib%name-qt3
%post_ldconfig

%postun -n lib%name-qt3
%postun_ldconfig

%post -n lib%name-qt4
%post_ldconfig

%postun -n lib%name-qt4
%postun_ldconfig

%post -n lib%name-ui
%post_ldconfig

%postun -n lib%name-ui
%postun_ldconfig

%post ui
%update_menus

%postun ui
%clean_menus

%files

%files daemon
%doc docs/* specs

%_initdir/avahi-daemon

%dir %_sysconfdir/avahi

%config %_sysconfdir/avahi/hosts

%config(noreplace) %_sysconfdir/avahi/avahi-daemon.conf

%dir %_sysconfdir/avahi/services
%config %_sysconfdir/avahi/services/ssh.service
%exclude %_sysconfdir/avahi/services/sftp-ssh.service

%config %_sysconfdir/dbus-1/system.d/avahi-dbus.conf

%_sbindir/avahi-daemon

%_datadir/avahi/*
%exclude %_datadir/avahi/interfaces

%_man5dir/*
%_man8dir/avahi-daemon.*

%_var/avahi
%attr(0771, root, _avahi) %dir /var/resolv/var/avahi
%attr(0770, root, _avahi) %dir %_var/run/avahi-daemon

%files autoipd
%dir %_sysconfdir/avahi
%config(noreplace) %_sysconfdir/avahi/avahi-autoipd.action
%_sbindir/avahi-autoipd
%_man8dir/avahi-autoipd.*
%attr(0770, root, %autoipd_user) %dir %_localstatedir/autoipd
%attr(0770, root, %autoipd_user) %dir %_var/run/autoipd

%files dnsconfd
%_initdir/avahi-dnsconfd
%config(noreplace) %_sysconfdir/avahi/avahi-dnsconfd.action
%_sbindir/avahi-dnsconfd
%_man8dir/avahi-dnsconfd.*

%files -n lib%name
%_libdir/libavahi-common.so.*
%_libdir/libavahi-core.so.*
%_libdir/libavahi-client.so.*

%if_with mdns
%_libdir/libdns_sd.so.*
%endif

%dir %_datadir/avahi
%dir %_datadir/avahi/interfaces

%dir %_libdir/avahi
%_libdir/avahi/service-types.db

%if_with python
%files bookmarks
%_bindir/avahi-bookmarks
%_man1dir/avahi-bookmarks.*
%endif # python

%files tools
%_bindir/avahi-browse*
%_bindir/avahi-publish*
%_bindir/avahi-resolve*
%_bindir/avahi-set-host-name

%_man1dir/avahi-browse*
%_man1dir/avahi-publish*
%_man1dir/avahi-resolve*
%_man1dir/avahi-set-host-name.*

%if_with python
%files ui
%_bindir/bshell
%_bindir/bssh
%_bindir/bvnc
%_bindir/avahi-discover
%_bindir/avahi-discover-standalone

%_datadir/avahi/interfaces/avahi-discover.glade
%_desktopdir/avahi-discover.desktop
%_desktopdir/bssh.desktop
%_desktopdir/bvnc.desktop

%python_sitelibdir/avahi_discover

%_man1dir/bssh.*
%_man1dir/bvnc.*
%_man1dir/avahi-discover.*
%endif #python

%files -n lib%name-devel
%_libdir/libavahi-common.so
%_libdir/libavahi-core.so
%_libdir/libavahi-client.so

%if_with mdns
%_libdir/libdns_sd.so
%endif

%_includedir/avahi-client
%_includedir/avahi-common
%_includedir/avahi-core

%if_with mdns
%_includedir/avahi-compat-libdns_sd
%endif

%_pkgconfigdir/avahi-core.pc
%_pkgconfigdir/avahi-client.pc

%if_with mdns
%_pkgconfigdir/avahi-compat-libdns_sd.pc
%endif

%files -n lib%name-glib
%_libdir/libavahi-glib.so.*

%files -n lib%name-glib-devel
%_libdir/libavahi-glib.so
%_includedir/avahi-glib
%_pkgconfigdir/avahi-glib.pc

%files -n lib%name-gobject
%_libdir/libavahi-gobject.so.*

%files -n lib%name-gobject-devel
%_libdir/libavahi-gobject.so
%_includedir/avahi-gobject
%_pkgconfigdir/avahi-gobject.pc

%files -n lib%name-qt3
%_libdir/libavahi-qt3.so.*

%files -n lib%name-qt3-devel
%_libdir/libavahi-qt3.so
%_pkgconfigdir/avahi-qt3.pc
%_includedir/avahi-qt3

%files -n lib%name-qt4
%_libdir/libavahi-qt4.so.*

%files -n lib%name-qt4-devel
%_libdir/libavahi-qt4.so
%_pkgconfigdir/avahi-qt4.pc
%_includedir/avahi-qt4

%files -n lib%name-ui
%_libdir/libavahi-ui.so.*

%files -n lib%name-ui-devel
%_libdir/libavahi-ui.so
%_pkgconfigdir/avahi-ui.pc
%_includedir/avahi-ui

%if_with mono
%files -n lib%name-sharp
%_monodir/avahi-sharp/avahi-sharp.dll
%_monogacdir/avahi-sharp
#_monodocdir/avahi-sharp
%_pkgconfigdir/avahi-sharp.pc

%files -n lib%name-ui-sharp
%_monodir/avahi-ui-sharp/avahi-ui-sharp.dll
%_monogacdir/avahi-ui-sharp
#_monodocdir/avahi-ui-sharp
%_pkgconfigdir/avahi-ui-sharp.pc
%endif # mono

%if_with python
%files -n python-module-%name
%python_sitelibdir/%name
%endif		    

%changelog
* Mon Mar 12 2012 Gleb F-Malinovskiy <glebfm@altlinux.org> 0.6.22-alt6.M41.2
- 4.1 security update (fix CVE-2011-1002)

* Fri Dec 02 2011 Andriy Stepanov <stanv@altlinux.ru> 0.6.22-alt6.M41.1
- CVE-2009-0758
  CVE-2010-2244

* Sat Feb 16 2008 Sergey Bolshakov <sbolshakov@altlinux.ru> 0.6.22-alt6
- fixed interpackage deps: qt[34] vs qt[34]-devel

* Wed Feb 13 2008 Sergey Bolshakov <sbolshakov@altlinux.ru> 0.6.22-alt5
- rebuilt against python 2.5

* Thu Jan  3 2008 Sergey Bolshakov <sbolshakov@altlinux.ru> 0.6.22-alt4
- made mono pkgconfig files compliant with alt's mono policy (#13862)

* Wed Dec 26 2007 Sergey Bolshakov <sbolshakov@altlinux.ru> 0.6.22-alt3
- build with automake >= 1.10 fixed

* Tue Dec 18 2007 Sergey Bolshakov <sbolshakov@altlinux.ru> 0.6.22-alt2
- build on x86_64 fixed

* Mon Dec 17 2007 Sergey Bolshakov <sbolshakov@altlinux.ru> 0.6.22-alt1
- 0.6.22
- mono bindings enabled by default

* Thu Sep  6 2007 Sergey Bolshakov <sbolshakov@altlinux.ru> 0.6.21-alt3
- do not announce sftp by default

* Fri Aug 31 2007 Sergey Bolshakov <sbolshakov@altlinux.ru> 0.6.21-alt2
- add default route on device after address selection by autoipd
- package missed avahi-daemon runtime dir

* Tue Aug 21 2007 Sergey Bolshakov <sbolshakov@altlinux.ru> 0.6.21-alt1
- 0.6.21 released

* Fri Jun 29 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.20-alt2
- reload dbus config instead of restart

* Tue Jun 26 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.20-alt1
- new version

* Tue May 22 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.19-alt1
- new version

* Tue Apr 24 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.18-alt2
- fix requires

* Fri Apr 20 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.18-alt1
- new version

* Tue Jan 09 2007 Sergey V Turchin <zerg at altlinux dot org> 0.6.16-alt1
- new version

* Tue Dec 26 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.15-alt4
- rebuilt with new dbus
- move %%_datadir/avahi ownership to libavahi

* Tue Dec 05 2006 Igor Zubkov <icesik@altlinux.org> 0.6.15-alt3
- NMU
- add patch from upstream for dbus 1.0

* Mon Nov 27 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.15-alt2
- add BuildRequires to libc-linux-headers
- built with python; thanks avm@alt

* Mon Nov 13 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.15-alt1
- new version

* Fri Oct 13 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.14-alt2
- remove requires to libc-linux-headers

* Mon Oct 02 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.14-alt1
- restart messagebus only on first install
- add group %avahi_group_priv
- built with Qt4

* Tue Aug 29 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.13-alt1
- new version

* Mon Jul 03 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.11-alt1
- new version

* Mon May 15 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.9-alt2
- rebuilt with new gcc

* Fri Mar 03 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.9-alt1
- new version
- fix username in initscript

* Mon Feb 27 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.8-alt1
- new version
- rename avahi user to _avahi
- fix runtime directory path

* Tue Jan 10 2006 Sergey V Turchin <zerg at altlinux dot org> 0.6.1-alt3
- fix requires

* Fri Dec 16 2005 Sergey V Turchin <zerg at altlinux dot org> 0.6.1-alt2
- generate config at first start

* Wed Dec 14 2005 Sergey V Turchin <zerg at altlinux dot org> 0.6.1-alt1
- built for ALT
- built without howl by default

* Mon Nov 21 2005 Jason Vas Dias<jvdias@redhat.com> - 0.6-1
- Upgrade to upstream version 0.6 - now provides 'avahi-howl-compat'
  libraries / includes.

* Mon Nov 14 2005 Jason Vas Dias<jvdias@redhat.com> - 0.5.2-7
- fix bug 172034: fix ownership of /var/run/avahi-daemon/
- fix bug 172772: .spec file improvements from matthias@rpmforge.net

* Mon Oct 31 2005 Jason Vas Dias<jvdias@redhat.com> - 0.5.2-6
- put back avahi-devel Obsoletes: howl-devel

* Mon Oct 31 2005 Alexander Larsson <alexl@redhat.com> - 0.5.2-5
- Obsoletes howl, howl-libs, as we want to get rid of them on updates
- No provides yet, as the howl compat library is in Avahi 0.6.0.

* Sun Oct 30 2005 Florian La Roche <laroche@redhat.com>
- disable the Obsoletes: howl until the transition is complete

* Fri Oct 28 2005 Jason Vas Dias<jvdias@redhat.com> - 0.5.2-3
- change initscript to start avahi-daemon AFTER messagebus

* Wed Oct 26 2005 Karsten Hopp <karsten@redhat.de> 0.5.2-2
- add buildrequires dbus-python

* Fri Oct 21 2005 Alexander Larsson <alexl@redhat.com> - 0.5.2-1
- Initial package
